from django.db import models
from django.contrib.auth.models import User
from ckeditor.fields import RichTextField
# Create your models here.


# For Student Records and Challan Forms
class BankName(models.Model):
    bank = models.CharField(max_length = 100, default='Habib Bank Limited', verbose_name = 'Bank Name')

    class Meta:
        verbose_name_plural = 'Bank Name'


    def __str__(self):
        return self.bank



class BankAccount(models.Model):
    bank = models.ForeignKey(BankName, on_delete=models.CASCADE, verbose_name = 'Bank Name')
    account = models.CharField(max_length=30,  verbose_name = 'Bank Account No')

    class Meta:
        verbose_name_plural = 'Bank Account'

    def __str__(self):
        return self.account


prog = [
    ('Pharm-D', 'Pharm-D'),
]
class Admission(models.Model):
    # bank = models.ForeignKey(BankName, on_delete=models.CASCADE, verbose_name = 'Bank Name')
    account = models.ForeignKey(BankAccount, default= 1,  on_delete=models.CASCADE, verbose_name ='Bank Account')
    std_name = models.CharField(max_length = 50, verbose_name='Student Name')
    std_program = models.CharField(max_length=50, choices= prog, default=prog, verbose_name='Program')
    std_registration= models.CharField(max_length=50, default= '10,000', blank = True, verbose_name = 'Registration Fee')
    std_admission = models.CharField(max_length = 50, default = '10,000', blank = True, verbose_name = 'Admission Fee')
    std_welfare = models.CharField(max_length = 50, default = '10,000', blank = True, verbose_name ='Welfare Fund')
    std_lib_sec = models.CharField(max_length = 50, default = '10,000', blank = True, verbose_name = 'Library Security (Ref)')
    std_lab_sec = models.CharField(max_length = 50, default = '10,000', blank = True, verbose_name = 'Laboratory Security (Ref)')
    std_total = models.CharField(max_length = 50, blank=True, verbose_name = 'Total')
    date = models.DateField(default='2019-10-10')
    created_on = models.DateTimeField(auto_now_add = True)
    updated_on = models.DateTimeField(auto_now = True)


    class Meta:
        verbose_name_plural = 'Admission Challan Form'
    
    def date_pretty(self):
        return self.date.strftime('%b %e, %Y')
    
    def __str__(self):
        return self.std_name

profs = [
    ('1st Prof', '1st Prof'),
    ('2nd Prof', '2nd Prof'),
    ('3rd Prof', '3rd Prof'),
    ('4th Prof', '4th Prof'),
    ('5th Prof', '5th Prof')
]


class Students(models.Model):
    # bank = models.ForeignKey(BankName, on_delete=models.CASCADE, verbose_name = 'Bank Name')
    account = models.ForeignKey(BankAccount, default = 1, on_delete=models.CASCADE, verbose_name = 'Bank Account')
    std_name = models.CharField(max_length = 50, verbose_name='Student Name')
    std_program = models.CharField(max_length=50, choices= prog, default=prog, verbose_name='Program')
    std_prof = models.CharField(max_length=50, choices = profs, default=profs, verbose_name = 'Professional Year')
    std_fall = models.CharField(max_length=50, default='2019 - 20', verbose_name ='Session')
    # items
    std_tution_fee = models.CharField( max_length=50, default = '140,000', blank=True, verbose_name = 'Tution Fee')
    std_utility_charges = models.CharField( max_length=50, default = '15,000', blank= True, verbose_name = 'Utility Charges')
    std_misc_funds = models.CharField( max_length=50, default = '15,000', blank= True, verbose_name = 'Miscellaneous Funds')
    std_hospital_fee = models.CharField( max_length=50, default = '', blank = True, verbose_name = 'Hospital Fee')
    std_thesis = models.CharField( max_length=50, default = '', blank = True, verbose_name = 'Thesis / Project')
    std_total = models.CharField( max_length=50, blank = True, verbose_name = 'Total')

    # std_doc = models.CharField( max_length=50, verbose_name = 'Documents Verification Fee', blank = True)
    # std_id_card = models.CharField( max_length=50, verbose_name = 'Identity Card', blank = True)
    # std_transport = models.CharField( max_length=50, verbose_name = 'Transport Fee', blank = True)
    # std_sport = models.CharField( max_length=50, verbose_name = 'Sports Charges', blank = True)
    # std_total = models.CharField( max_length=50, verbose_name = 'Total ')
    
    date = models.DateField(default='2019-10-10')
    created_on = models.DateTimeField(auto_now_add = True)
    updated_on = models.DateTimeField(auto_now = True)

    class Meta:
        verbose_name_plural = 'Professionals Fee Challan'
    
    def date_pretty(self):
        return self.date.strftime('%b %e, %Y')
    
    def __str__(self):
        return self.std_name